libstdc++: std::num_get< _CharT, _InIter > Class Template Reference

libstdc++

std::num_get< _CharT, _InIter > Class Template Reference
Locales

`#include <locale_facets.h>`

Inheritance diagram for std::num_get< _CharT, _InIter >:
[legend]

## Public Types
typedef _CharT | char_type
typedef _InIter | iter_type

## Public Member Functions
| num_get (size_t __refs=0)
template<typename _ValueT>
_InIter | _M_extract_int (_InIter __beg, _InIter __end, ios_base &__io, ios_base::iostate &__err, _ValueT &__v) const
iter_type | get (iter_type __in, iter_type __end, ios_base &__io, ios_base::iostate &__err, bool &__v) const
iter_type | get (iter_type __in, iter_type __end, ios_base &__io, ios_base::iostate &__err, void *&__v) const
iter_type | get (iter_type __in, iter_type __end, ios_base &__io, ios_base::iostate &__err, long &__v) const
iter_type | get (iter_type __in, iter_type __end, ios_base &__io, ios_base::iostate &__err, unsigned short &__v) const
iter_type | get (iter_type __in, iter_type __end, ios_base &__io, ios_base::iostate &__err, unsigned int &__v) const
iter_type | get (iter_type __in, iter_type __end, ios_base &__io, ios_base::iostate &__err, unsigned long &__v) const
iter_type | get (iter_type __in, iter_type __end, ios_base &__io, ios_base::iostate &__err, long long &__v) const
iter_type | get (iter_type __in, iter_type __end, ios_base &__io, ios_base::iostate &__err, unsigned long long &__v) const
iter_type | get (iter_type __in, iter_type __end, ios_base &__io, ios_base::iostate &__err, float &__v) const
iter_type | get (iter_type __in, iter_type __end, ios_base &__io, ios_base::iostate &__err, double &__v) const
iter_type | get (iter_type __in, iter_type __end, ios_base &__io, ios_base::iostate &__err, long double &__v) const

## Static Public Attributes
static locale::id | id

## Protected Member Functions
virtual | ~num_get ()
iter_type | _M_extract_float (iter_type, iter_type, ios_base &, ios_base::iostate &, string &) const
template<typename _ValueT>
iter_type | _M_extract_int (iter_type, iter_type, ios_base &, ios_base::iostate &, _ValueT &) const
template<typename _CharT2>
__gnu_cxx::__enable_if< __is_char< _CharT2 >::__value, int >::__type | _M_find (const _CharT2 *, size_t __len, _CharT2 __c) const
template<typename _CharT2>
__gnu_cxx::__enable_if<!__is_char< _CharT2 >::__value, int >::__type | _M_find (const _CharT2 *__zero, size_t __len, _CharT2 __c) const
virtual iter_type | do_get (iter_type, iter_type, ios_base &, ios_base::iostate &, bool &) const
virtual iter_type | do_get (iter_type __beg, iter_type __end, ios_base &__io, ios_base::iostate &__err, long &__v) const
virtual iter_type | do_get (iter_type __beg, iter_type __end, ios_base &__io, ios_base::iostate &__err, unsigned short &__v) const
virtual iter_type | do_get (iter_type __beg, iter_type __end, ios_base &__io, ios_base::iostate &__err, unsigned int &__v) const
virtual iter_type | do_get (iter_type __beg, iter_type __end, ios_base &__io, ios_base::iostate &__err, unsigned long &__v) const
virtual iter_type | do_get (iter_type __beg, iter_type __end, ios_base &__io, ios_base::iostate &__err, long long &__v) const
virtual iter_type | do_get (iter_type __beg, iter_type __end, ios_base &__io, ios_base::iostate &__err, unsigned long long &__v) const
virtual iter_type | do_get (iter_type, iter_type, ios_base &, ios_base::iostate &, float &) const
virtual iter_type | do_get (iter_type, iter_type, ios_base &, ios_base::iostate &, double &) const
virtual iter_type | do_get (iter_type, iter_type, ios_base &, ios_base::iostate &, long double &) const
virtual iter_type | do_get (iter_type, iter_type, ios_base &, ios_base::iostate &, void *&) const

## Static Protected Member Functions
static __c_locale | _S_clone_c_locale (__c_locale &__cloc) throw ()
static void | _S_create_c_locale (__c_locale &__cloc, const char *__s, __c_locale __old=0)
static void | _S_destroy_c_locale (__c_locale &__cloc)
static __c_locale | _S_get_c_locale ()
static const char * | _S_get_c_name () throw ()
static __c_locale | _S_lc_ctype_c_locale (__c_locale __cloc, const char *__s)

## Detailed Description

template<typename _CharT, typename _InIter>
class std::num_get< _CharT, _InIter >

Primary class template num_get.

This facet encapsulates the code to parse and return a number from a string. It is used by the istream numeric extraction operators.

The num_get template uses protected virtual functions to provide the actual results. The public accessors forward the call to the virtual functions. These virtual functions are hooks for developers to implement the behavior they require from the num_get facet.

Definition at line 1960 of file locale_facets.h.

## Member Typedef Documentation

## ◆ char_type

template<typename _CharT, typename _InIter>

typedef _CharT std::num_get< _CharT, _InIter >::char_type

Public typedefs.

Definition at line 1966 of file locale_facets.h.

## ◆ iter_type

template<typename _CharT, typename _InIter>

typedef _InIter std::num_get< _CharT, _InIter >::iter_type

Public typedefs.

Definition at line 1967 of file locale_facets.h.

## Constructor & Destructor Documentation

## ◆ num_get()

template<typename _CharT, typename _InIter>

std::num_get< _CharT, _InIter >::num_get | ( | size_t | __refs = 0 | ) |
| inlineexplicit

Constructor performs initialization.

This is the constructor provided by the standard.

Parameters

  __refs | Passed to the base facet class.

Definition at line 1981 of file locale_facets.h.

## ◆ ~num_get()

template<typename _CharT, typename _InIter>

virtual std::num_get< _CharT, _InIter >::~num_get | ( |  | ) |
| inlineprotectedvirtual

Destructor.

Definition at line 2156 of file locale_facets.h.

## Member Function Documentation

## ◆ _M_extract_float()

template<typename _CharT, typename _InIter>

_InIter std::num_get< _CharT, _InIter >::_M_extract_float | ( | iter_type | __beg,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | string & | __xtrc ) const
| protected

Definition at line 152 of file locale_facets.tcc.

## ◆ _M_extract_int()

template<typename _CharT, typename _InIter>
template<typename _ValueT>

_InIter std::num_get< _CharT, _InIter >::_M_extract_int | ( | _InIter | __beg,
|  | _InIter | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | _ValueT & | __v ) const

Definition at line 378 of file locale_facets.tcc.

## ◆ _M_find() [1/2]

template<typename _CharT, typename _InIter>
template<typename _CharT2>

__gnu_cxx::__enable_if< __is_char< _CharT2 >::__value, int >::__type std::num_get< _CharT, _InIter >::_M_find | ( | const _CharT2 * | ,
|  | size_t | __len,
|  | _CharT2 | __c ) const
| inlineprotected

Definition at line 2171 of file locale_facets.h.

## ◆ _M_find() [2/2]

template<typename _CharT, typename _InIter>
template<typename _CharT2>

__gnu_cxx::__enable_if<!__is_char< _CharT2 >::__value, int >::__type std::num_get< _CharT, _InIter >::_M_find | ( | const _CharT2 * | __zero,
|  | size_t | __len,
|  | _CharT2 | __c ) const
| inlineprotected

Definition at line 2194 of file locale_facets.h.

## ◆ do_get() [1/11]

template<typename _CharT, typename _InIter>

virtual iter_type std::num_get< _CharT, _InIter >::do_get | ( | iter_type | __beg,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | long & | __v ) const
| inlineprotectedvirtual

Numeric parsing.

Parses the input stream into the variable v. This function is a hook for derived classes to change the value returned.

See also
  get() for more details.

Parameters

  __beg | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2226 of file locale_facets.h.

## ◆ do_get() [2/11]

template<typename _CharT, typename _InIter>

virtual iter_type std::num_get< _CharT, _InIter >::do_get | ( | iter_type | __beg,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | long long & | __v ) const
| inlineprotectedvirtual

Numeric parsing.

Parses the input stream into the variable v. This function is a hook for derived classes to change the value returned.

See also
  get() for more details.

Parameters

  __beg | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2249 of file locale_facets.h.

## ◆ do_get() [3/11]

template<typename _CharT, typename _InIter>

virtual iter_type std::num_get< _CharT, _InIter >::do_get | ( | iter_type | __beg,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | unsigned int & | __v ) const
| inlineprotectedvirtual

Numeric parsing.

Parses the input stream into the variable v. This function is a hook for derived classes to change the value returned.

See also
  get() for more details.

Parameters

  __beg | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2236 of file locale_facets.h.

## ◆ do_get() [4/11]

template<typename _CharT, typename _InIter>

virtual iter_type std::num_get< _CharT, _InIter >::do_get | ( | iter_type | __beg,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | unsigned long & | __v ) const
| inlineprotectedvirtual

Numeric parsing.

Parses the input stream into the variable v. This function is a hook for derived classes to change the value returned.

See also
  get() for more details.

Parameters

  __beg | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2241 of file locale_facets.h.

## ◆ do_get() [5/11]

template<typename _CharT, typename _InIter>

virtual iter_type std::num_get< _CharT, _InIter >::do_get | ( | iter_type | __beg,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | unsigned long long & | __v ) const
| inlineprotectedvirtual

Numeric parsing.

Parses the input stream into the variable v. This function is a hook for derived classes to change the value returned.

See also
  get() for more details.

Parameters

  __beg | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2254 of file locale_facets.h.

## ◆ do_get() [6/11]

template<typename _CharT, typename _InIter>

virtual iter_type std::num_get< _CharT, _InIter >::do_get | ( | iter_type | __beg,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | unsigned short & | __v ) const
| inlineprotectedvirtual

Numeric parsing.

Parses the input stream into the variable v. This function is a hook for derived classes to change the value returned.

See also
  get() for more details.

Parameters

  __beg | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2231 of file locale_facets.h.

## ◆ do_get() [7/11]

template<typename _CharT, typename _InIter>

_InIter std::num_get< _CharT, _InIter >::do_get | ( | iter_type | __beg,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | bool & | __v ) const
| protectedvirtual

Numeric parsing.

Parses the input stream into the variable v. This function is a hook for derived classes to change the value returned.

See also
  get() for more details.

Parameters

  __beg | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 598 of file locale_facets.tcc.

References std::ios_base::_M_getloc(), std::ios_base::boolalpha, std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::flags(), and std::ios_base::goodbit.

Referenced by std::num_get< _CharT, istreambuf_iterator< _CharT, _Traits > >::get(), std::num_get< _CharT, istreambuf_iterator< _CharT, _Traits > >::get(), std::num_get< _CharT, istreambuf_iterator< _CharT, _Traits > >::get(), std::num_get< _CharT, istreambuf_iterator< _CharT, _Traits > >::get(), std::num_get< _CharT, istreambuf_iterator< _CharT, _Traits > >::get(), std::num_get< _CharT, istreambuf_iterator< _CharT, _Traits > >::get(), std::num_get< _CharT, istreambuf_iterator< _CharT, _Traits > >::get(), std::num_get< _CharT, istreambuf_iterator< _CharT, _Traits > >::get(), std::num_get< _CharT, istreambuf_iterator< _CharT, _Traits > >::get(), std::num_get< _CharT, istreambuf_iterator< _CharT, _Traits > >::get(), and std::num_get< _CharT, istreambuf_iterator< _CharT, _Traits > >::get().

## ◆ do_get() [8/11]

template<typename _CharT, typename _InIter>

_InIter std::num_get< _CharT, _InIter >::do_get | ( | iter_type | __beg,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | double & | __v ) const
| protectedvirtual

Numeric parsing.

Parses the input stream into the variable v. This function is a hook for derived classes to change the value returned.

See also
  get() for more details.

Parameters

  __beg | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 709 of file locale_facets.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::c_str(), std::ios_base::eofbit, and std::basic_string< _CharT, _Traits, _Alloc >::reserve().

## ◆ do_get() [9/11]

template<typename _CharT, typename _InIter>

_InIter std::num_get< _CharT, _InIter >::do_get | ( | iter_type | __beg,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | float & | __v ) const
| protectedvirtual

Numeric parsing.

Parses the input stream into the variable v. This function is a hook for derived classes to change the value returned.

See also
  get() for more details.

Parameters

  __beg | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 694 of file locale_facets.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::c_str(), std::ios_base::eofbit, and std::basic_string< _CharT, _Traits, _Alloc >::reserve().

## ◆ do_get() [10/11]

template<typename _CharT, typename _InIter>

_InIter std::num_get< _CharT, _InIter >::do_get | ( | iter_type | __beg,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | long double & | __v ) const
| protectedvirtual

Numeric parsing.

Parses the input stream into the variable v. This function is a hook for derived classes to change the value returned.

See also
  get() for more details.

Parameters

  __beg | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 741 of file locale_facets.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::c_str(), std::ios_base::eofbit, and std::basic_string< _CharT, _Traits, _Alloc >::reserve().

## ◆ do_get() [11/11]

template<typename _CharT, typename _InIter>

_InIter std::num_get< _CharT, _InIter >::do_get | ( | iter_type | __beg,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | void *& | __v ) const
| protectedvirtual

Numeric parsing.

Parses the input stream into the variable v. This function is a hook for derived classes to change the value returned.

See also
  get() for more details.

Parameters

  __beg | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 756 of file locale_facets.tcc.

References std::ios_base::basefield, std::ios_base::flags(), and std::ios_base::hex.

## ◆ get() [1/11]

template<typename _CharT, typename _InIter>

iter_type std::num_get< _CharT, _InIter >::get | ( | iter_type | __in,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | bool & | __v ) const
| inline

Numeric parsing.

Parses the input stream into the bool v. It does so by calling num_get::do_get().

If ios_base::boolalpha is set, attempts to read ctype<CharT>::truename() or ctype<CharT>::falsename(). Sets v to true or false if successful. Sets err to ios_base::failbit if reading the string fails. Sets err to ios_base::eofbit if the stream is emptied.

If ios_base::boolalpha is not set, proceeds as with reading a long, except if the value is 1, sets v to true, if the value is 0, sets v to false, and otherwise set err to ios_base::failbit.

Parameters

  __in | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2007 of file locale_facets.h.

Referenced by std::basic_iostream< char_type, traits_type >::operator>>(), and std::basic_istream< _CharT, _Traits >::operator>>().

## ◆ get() [2/11]

template<typename _CharT, typename _InIter>

iter_type std::num_get< _CharT, _InIter >::get | ( | iter_type | __in,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | double & | __v ) const
| inline

Numeric parsing.

Parses the input stream into the integral variable v. It does so by calling num_get::do_get().

The input characters are parsed like the scanf g specifier. The matching type length modifier is also used.

The decimal point character used is numpunct::decimal_point(). Digit grouping is interpreted according to numpunct::grouping() and numpunct::thousands_sep(). If the pattern of digit groups isn't consistent, sets err to ios_base::failbit.

If parsing the string yields a valid value for v, v is set. Otherwise, sets err to ios_base::failbit and leaves v unaltered. Sets err to ios_base::eofbit if the stream is emptied.

Parameters

  __in | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2112 of file locale_facets.h.

## ◆ get() [3/11]

template<typename _CharT, typename _InIter>

iter_type std::num_get< _CharT, _InIter >::get | ( | iter_type | __in,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | float & | __v ) const
| inline

Numeric parsing.

Parses the input stream into the integral variable v. It does so by calling num_get::do_get().

The input characters are parsed like the scanf g specifier. The matching type length modifier is also used.

The decimal point character used is numpunct::decimal_point(). Digit grouping is interpreted according to numpunct::grouping() and numpunct::thousands_sep(). If the pattern of digit groups isn't consistent, sets err to ios_base::failbit.

If parsing the string yields a valid value for v, v is set. Otherwise, sets err to ios_base::failbit and leaves v unaltered. Sets err to ios_base::eofbit if the stream is emptied.

Parameters

  __in | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2107 of file locale_facets.h.

## ◆ get() [4/11]

template<typename _CharT, typename _InIter>

iter_type std::num_get< _CharT, _InIter >::get | ( | iter_type | __in,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | long & | __v ) const
| inline

Numeric parsing.

Parses the input stream into the integral variable v. It does so by calling num_get::do_get().

Parsing is affected by the flag settings in io.

The basic parse is affected by the value of io.flags() & ios_base::basefield. If equal to ios_base::oct, parses like the scanf o specifier. Else if equal to ios_base::hex, parses like X specifier. Else if basefield equal to 0, parses like the i specifier. Otherwise, parses like d for signed and u for unsigned types. The matching type length modifier is also used.

Digit grouping is interpreted according to numpunct::grouping() and numpunct::thousands_sep(). If the pattern of digit groups isn't consistent, sets err to ios_base::failbit.

If parsing the string yields a valid value for v, v is set. Otherwise, sets err to ios_base::failbit and leaves v unaltered. Sets err to ios_base::eofbit if the stream is emptied.

Parameters

  __in | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2044 of file locale_facets.h.

## ◆ get() [5/11]

template<typename _CharT, typename _InIter>

iter_type std::num_get< _CharT, _InIter >::get | ( | iter_type | __in,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | long double & | __v ) const
| inline

Numeric parsing.

Parses the input stream into the integral variable v. It does so by calling num_get::do_get().

The input characters are parsed like the scanf g specifier. The matching type length modifier is also used.

The decimal point character used is numpunct::decimal_point(). Digit grouping is interpreted according to numpunct::grouping() and numpunct::thousands_sep(). If the pattern of digit groups isn't consistent, sets err to ios_base::failbit.

If parsing the string yields a valid value for v, v is set. Otherwise, sets err to ios_base::failbit and leaves v unaltered. Sets err to ios_base::eofbit if the stream is emptied.

Parameters

  __in | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2117 of file locale_facets.h.

## ◆ get() [6/11]

template<typename _CharT, typename _InIter>

iter_type std::num_get< _CharT, _InIter >::get | ( | iter_type | __in,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | long long & | __v ) const
| inline

Numeric parsing.

Parses the input stream into the integral variable v. It does so by calling num_get::do_get().

Parsing is affected by the flag settings in io.

The basic parse is affected by the value of io.flags() & ios_base::basefield. If equal to ios_base::oct, parses like the scanf o specifier. Else if equal to ios_base::hex, parses like X specifier. Else if basefield equal to 0, parses like the i specifier. Otherwise, parses like d for signed and u for unsigned types. The matching type length modifier is also used.

Digit grouping is interpreted according to numpunct::grouping() and numpunct::thousands_sep(). If the pattern of digit groups isn't consistent, sets err to ios_base::failbit.

If parsing the string yields a valid value for v, v is set. Otherwise, sets err to ios_base::failbit and leaves v unaltered. Sets err to ios_base::eofbit if the stream is emptied.

Parameters

  __in | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2067 of file locale_facets.h.

## ◆ get() [7/11]

template<typename _CharT, typename _InIter>

iter_type std::num_get< _CharT, _InIter >::get | ( | iter_type | __in,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | unsigned int & | __v ) const
| inline

Numeric parsing.

Parses the input stream into the integral variable v. It does so by calling num_get::do_get().

Parsing is affected by the flag settings in io.

The basic parse is affected by the value of io.flags() & ios_base::basefield. If equal to ios_base::oct, parses like the scanf o specifier. Else if equal to ios_base::hex, parses like X specifier. Else if basefield equal to 0, parses like the i specifier. Otherwise, parses like d for signed and u for unsigned types. The matching type length modifier is also used.

Digit grouping is interpreted according to numpunct::grouping() and numpunct::thousands_sep(). If the pattern of digit groups isn't consistent, sets err to ios_base::failbit.

If parsing the string yields a valid value for v, v is set. Otherwise, sets err to ios_base::failbit and leaves v unaltered. Sets err to ios_base::eofbit if the stream is emptied.

Parameters

  __in | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2054 of file locale_facets.h.

## ◆ get() [8/11]

template<typename _CharT, typename _InIter>

iter_type std::num_get< _CharT, _InIter >::get | ( | iter_type | __in,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | unsigned long & | __v ) const
| inline

Numeric parsing.

Parses the input stream into the integral variable v. It does so by calling num_get::do_get().

Parsing is affected by the flag settings in io.

The basic parse is affected by the value of io.flags() & ios_base::basefield. If equal to ios_base::oct, parses like the scanf o specifier. Else if equal to ios_base::hex, parses like X specifier. Else if basefield equal to 0, parses like the i specifier. Otherwise, parses like d for signed and u for unsigned types. The matching type length modifier is also used.

Digit grouping is interpreted according to numpunct::grouping() and numpunct::thousands_sep(). If the pattern of digit groups isn't consistent, sets err to ios_base::failbit.

If parsing the string yields a valid value for v, v is set. Otherwise, sets err to ios_base::failbit and leaves v unaltered. Sets err to ios_base::eofbit if the stream is emptied.

Parameters

  __in | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2059 of file locale_facets.h.

## ◆ get() [9/11]

template<typename _CharT, typename _InIter>

iter_type std::num_get< _CharT, _InIter >::get | ( | iter_type | __in,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | unsigned long long & | __v ) const
| inline

Numeric parsing.

Parses the input stream into the integral variable v. It does so by calling num_get::do_get().

Parsing is affected by the flag settings in io.

The basic parse is affected by the value of io.flags() & ios_base::basefield. If equal to ios_base::oct, parses like the scanf o specifier. Else if equal to ios_base::hex, parses like X specifier. Else if basefield equal to 0, parses like the i specifier. Otherwise, parses like d for signed and u for unsigned types. The matching type length modifier is also used.

Digit grouping is interpreted according to numpunct::grouping() and numpunct::thousands_sep(). If the pattern of digit groups isn't consistent, sets err to ios_base::failbit.

If parsing the string yields a valid value for v, v is set. Otherwise, sets err to ios_base::failbit and leaves v unaltered. Sets err to ios_base::eofbit if the stream is emptied.

Parameters

  __in | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2072 of file locale_facets.h.

## ◆ get() [10/11]

template<typename _CharT, typename _InIter>

iter_type std::num_get< _CharT, _InIter >::get | ( | iter_type | __in,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | unsigned short & | __v ) const
| inline

Numeric parsing.

Parses the input stream into the integral variable v. It does so by calling num_get::do_get().

Parsing is affected by the flag settings in io.

The basic parse is affected by the value of io.flags() & ios_base::basefield. If equal to ios_base::oct, parses like the scanf o specifier. Else if equal to ios_base::hex, parses like X specifier. Else if basefield equal to 0, parses like the i specifier. Otherwise, parses like d for signed and u for unsigned types. The matching type length modifier is also used.

Digit grouping is interpreted according to numpunct::grouping() and numpunct::thousands_sep(). If the pattern of digit groups isn't consistent, sets err to ios_base::failbit.

If parsing the string yields a valid value for v, v is set. Otherwise, sets err to ios_base::failbit and leaves v unaltered. Sets err to ios_base::eofbit if the stream is emptied.

Parameters

  __in | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2049 of file locale_facets.h.

## ◆ get() [11/11]

template<typename _CharT, typename _InIter>

iter_type std::num_get< _CharT, _InIter >::get | ( | iter_type | __in,
|  | iter_type | __end,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | void *& | __v ) const
| inline

Numeric parsing.

Parses the input stream into the pointer variable v. It does so by calling num_get::do_get().

The input characters are parsed like the scanf p specifier.

Digit grouping is interpreted according to numpunct::grouping() and numpunct::thousands_sep(). If the pattern of digit groups isn't consistent, sets err to ios_base::failbit.

Note that the digit grouping effect for pointers is a bit ambiguous in the standard and shouldn't be relied on. See DR 344.

If parsing the string yields a valid value for v, v is set. Otherwise, sets err to ios_base::failbit and leaves v unaltered. Sets err to ios_base::eofbit if the stream is emptied.

Parameters

  __in | Start of input stream.
  __end | End of input stream.
  __io | Source of locale and flags.
  __err | Error flags to set.
  __v | Value to format and insert.

Returns
  Iterator after reading.

Definition at line 2150 of file locale_facets.h.

## Member Data Documentation

## ◆ id

template<typename _CharT, typename _InIter>

locale::id std::num_get< _CharT, _InIter >::id
| static

Numpunct facet id.

Definition at line 1971 of file locale_facets.h.

The documentation for this class was generated from the following files:

- locale_facets.h
- locale_facets.tcc